#include <stdio.h>
#include <stdlib.h>
#include <glpk.h>
#include <set>
#include "maxflow.hpp"
#include "mincut.hpp"

short *visited;
Cut *myCut;

void dfs(int vertex, int numEdges, int **Adj, int **Edges){
	int i;
	
	//printf("starting %d\n",vertex);
	//printf("%d ,",vertex+1);
	visited[vertex] = 1;
	myCut->S->insert(vertex+1);
	myCut->Sbar->erase(vertex+1);
	
	for(i=0;i<numEdges;i++){
		//printf("%d, %d -> (%d,%d)\n",i,Adj[vertex][i], Edges[0][i], Edges[1][i]);
		if(Adj[vertex][i]!=0){
			if(Edges[0][i] == vertex && visited[Edges[1][i]]==0){
				dfs(Edges[1][i], numEdges, Adj, Edges);
			}else if(Edges[1][i] == vertex && visited[Edges[0][i]]==0){
				dfs(Edges[0][i], numEdges, Adj, Edges);
			}
		}
	}
	//printf("visited all neighbours of %d\n",vertex);
}

Cut *mincut(int numVertices, int numEdges, int **Adj, float *capacities, int **Edges, int s, int t){
	int i,j;
	
	glp_prob *lp = maxFlow(numVertices,numEdges,Adj,capacities,s,t);
	
	//Calculate residue graph by clearing saturated edges in either
	//direction
	for(j=0;j<numEdges;j++){
		//printf("%lf,%f\n",glp_get_col_prim(lp,j+1),capacities[j]);
		if(abs(glp_get_col_prim(lp,j+1))==capacities[j]){
			for(i=0;i<numVertices;i++){
				Adj[i][j]=0;
			}
		}
	}
	
	//printData(numVertices,numEdges, Adj, capacities);
	
	//Reachability from start node
	myCut = new Cut(new SetOfIntSet(), new SetOfIntSet());
	for(i=0;i<numVertices;i++){
		myCut->Sbar->insert(i+1);
	}
	visited  = (short *)calloc(numVertices,sizeof(short));
	dfs(s-1, numEdges, Adj, Edges);
	free(visited);
	
	myCut->weight = glp_get_obj_val(lp);
	
	return myCut;
	
}

